/*
 * This file is part of the Nepomuk KDE project.
 * Copyright (c) 2009 Sebastian Trueg <trueg@kde.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef _OLENA_ANNOTATIONPLUGIN_H_
#define _OLENA_ANNOTATIONPLUGIN_H_

#include "metaannotationplugin.h"

#include <soprano/soprano.h>
#include <KPluginFactory>
#include <KPluginLoader>

class KJob;

namespace Nepomuk {

    class OlenaTextExtractionJob;

    class OlenaAnnotationPlugin : public MetaAnnotationPlugin
    {
        Q_OBJECT

    public:
        OlenaAnnotationPlugin(QObject* parent, const QList<QVariant>&);
        ~OlenaAnnotationPlugin();

    private Q_SLOTS:
        void slotMimetypeJobResult( KJob* job );
        void slotTextExtractionDone( KJob* job );

    private:
        void doGetPossibleAnnotations( const AnnotationRequest& request );

        KJob* m_currentMimeTypeJob;
        OlenaTextExtractionJob* m_currentTextExtractionJob;
    };

} // End namespace Nepomuk

#endif
