/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _TASK_H_
#define _TASK_H_

class QDateTime;
class QDate;
class QTime;

namespace Nepomuk {
    class Task;
    class Resource;

}

#include <nepomuk/resource.h>


namespace Nepomuk {

    /**
     * The tmo:task is the central entitiey of the tmo. Task can range 
     * from vague things to be possibly done in e distant future to concrete 
     * things to be done in a precise forseeable manner. It is not unrealisitc 
     * to assume that knowledge worker have hundred or more tasks a 
     * day. 
     */
    class  Task : public Resource
    {
    public:
        /**
         * Create a new empty and invalid Task instance
         */
        Task();
        Task( ResourceManager* );

        /**
         * Default copy constructor
         */
        Task( const Task& );
        Task( const Resource& );

        /**
         * Create a new Task instance representing the resource
         * referenced by \a uriOrIdentifier.
         */
        Task( const QString& uriOrIdentifier );
        Task( const QString& uriOrIdentifier, ResourceManager* );

        /**
         * Create a new Task instance representing the resource
         * referenced by \a uri.
         */
        Task( const QUrl& uri );
        Task( const QUrl& uri, ResourceManager* );
        ~Task();

        Task& operator=( const Task& );

        /**
         * Get property 'dueDate'. 
         */
        QDateTime dueDate() const;

        /**
         * Set property 'dueDate'. 
         */
        void setDueDate( const QDateTime& value );

        /**
         * \return The URI of the property 'dueDate'. 
         */
        static QUrl dueDateUri();

        /**
         * Get property 'actualCompletion'. 
         */
        QString actualCompletion() const;

        /**
         * Set property 'actualCompletion'. 
         */
        void setActualCompletion( const QString& value );

        /**
         * \return The URI of the property 'actualCompletion'. 
         */
        static QUrl actualCompletionUri();

        /**
         * Get property 'urgency'. 
         */
        Resource urgency() const;

        /**
         * Set property 'urgency'. 
         */
        void setUrgency( const Resource& value );

        /**
         * \return The URI of the property 'urgency'. 
         */
        static QUrl urgencyUri();

        /**
         * Get property 'dependency'. 
         */
        QList<Resource> dependencys() const;

        /**
         * Set property 'dependency'. 
         */
        void setDependencys( const QList<Resource>& value );

        /**
         * Add a value to property 'dependency'. 
         */
        void addDependency( const Resource& value );

        /**
         * \return The URI of the property 'dependency'. 
         */
        static QUrl dependencyUri();

        /**
         * Get property 'targetStartTime'. 
         */
        QDateTime targetStartTime() const;

        /**
         * Set property 'targetStartTime'. 
         */
        void setTargetStartTime( const QDateTime& value );

        /**
         * \return The URI of the property 'targetStartTime'. 
         */
        static QUrl targetStartTimeUri();

        /**
         * Get property 'taskId'. The Task Identifier allows a unique 
         * identification of a task object within the range of all Nepomuk 
         * objects. The Task Identifier is automatically generated during 
         * the creation of a task. The generation of identifiers (IDs) 
         * is a Nepomuk architecture issue (Wp2000/WP6000). 
         */
        QString taskId() const;

        /**
         * Set property 'taskId'. The Task Identifier allows a unique 
         * identification of a task object within the range of all Nepomuk 
         * objects. The Task Identifier is automatically generated during 
         * the creation of a task. The generation of identifiers (IDs) 
         * is a Nepomuk architecture issue (Wp2000/WP6000). 
         */
        void setTaskId( const QString& value );

        /**
         * \return The URI of the property 'taskId'. 
         */
        static QUrl taskIdUri();

        /**
         * Get property 'priority'. 
         */
        Resource priority() const;

        /**
         * Set property 'priority'. 
         */
        void setPriority( const Resource& value );

        /**
         * \return The URI of the property 'priority'. 
         */
        static QUrl priorityUri();

        /**
         * Get property 'involvedPersons'. 
         */
        QList<Resource> involvedPersonses() const;

        /**
         * Set property 'involvedPersons'. 
         */
        void setInvolvedPersonses( const QList<Resource>& value );

        /**
         * Add a value to property 'involvedPersons'. 
         */
        void addInvolvedPersons( const Resource& value );

        /**
         * \return The URI of the property 'involvedPersons'. 
         */
        static QUrl involvedPersonsUri();

        /**
         * Get property 'indexPosition'. 
         */
        QString indexPosition() const;

        /**
         * Set property 'indexPosition'. 
         */
        void setIndexPosition( const QString& value );

        /**
         * \return The URI of the property 'indexPosition'. 
         */
        static QUrl indexPositionUri();

        /**
         * Get property 'targetEndTime'. 
         */
        QDateTime targetEndTime() const;

        /**
         * Set property 'targetEndTime'. 
         */
        void setTargetEndTime( const QDateTime& value );

        /**
         * \return The URI of the property 'targetEndTime'. 
         */
        static QUrl targetEndTimeUri();

        /**
         * Get property 'superTask'. 
         */
        Task superTask() const;

        /**
         * Set property 'superTask'. 
         */
        void setSuperTask( const Task& value );

        /**
         * \return The URI of the property 'superTask'. 
         */
        static QUrl superTaskUri();

        /**
         * Get property 'abilityCarrierInvolvement'. 
         */
        QList<Resource> abilityCarrierInvolvements() const;

        /**
         * Set property 'abilityCarrierInvolvement'. 
         */
        void setAbilityCarrierInvolvements( const QList<Resource>& value );

        /**
         * Add a value to property 'abilityCarrierInvolvement'. 
         */
        void addAbilityCarrierInvolvement( const Resource& value );

        /**
         * \return The URI of the property 'abilityCarrierInvolvement'. 
         */
        static QUrl abilityCarrierInvolvementUri();

        /**
         * Get property 'actualStartTime'. 
         */
        QDateTime actualStartTime() const;

        /**
         * Set property 'actualStartTime'. 
         */
        void setActualStartTime( const QDateTime& value );

        /**
         * \return The URI of the property 'actualStartTime'. 
         */
        static QUrl actualStartTimeUri();

        /**
         * Get property 'taskTransmission'. 
         */
        QList<Resource> taskTransmissions() const;

        /**
         * Set property 'taskTransmission'. 
         */
        void setTaskTransmissions( const QList<Resource>& value );

        /**
         * Add a value to property 'taskTransmission'. 
         */
        void addTaskTransmission( const Resource& value );

        /**
         * \return The URI of the property 'taskTransmission'. 
         */
        static QUrl taskTransmissionUri();

        /**
         * Get property 'targetCompletion'. 
         */
        QString targetCompletion() const;

        /**
         * Set property 'targetCompletion'. 
         */
        void setTargetCompletion( const QString& value );

        /**
         * \return The URI of the property 'targetCompletion'. 
         */
        static QUrl targetCompletionUri();

        /**
         * Get property 'nextReviewIntervall'. 
         */
        qint64 nextReviewIntervall() const;

        /**
         * Set property 'nextReviewIntervall'. 
         */
        void setNextReviewIntervall( const qint64& value );

        /**
         * \return The URI of the property 'nextReviewIntervall'. 
         */
        static QUrl nextReviewIntervallUri();

        /**
         * Get property 'taskState'. The task state describes the current 
         * state of the task as described in Section 5.2.7. 
         */
        Resource taskState() const;

        /**
         * Set property 'taskState'. The task state describes the current 
         * state of the task as described in Section 5.2.7. 
         */
        void setTaskState( const Resource& value );

        /**
         * \return The URI of the property 'taskState'. 
         */
        static QUrl taskStateUri();

        /**
         * Get property 'delegability'. 
         */
        Resource delegability() const;

        /**
         * Set property 'delegability'. 
         */
        void setDelegability( const Resource& value );

        /**
         * \return The URI of the property 'delegability'. 
         */
        static QUrl delegabilityUri();

        /**
         * Get property 'taskPrivacyState'. For the separation between 
         * professional and private purpose of a task, this attribute 
         * provides with the values "professional/private" a high level 
         * separation of privacy in terms of setting distribution rights 
         * to other users for the task. This separation may arise as a general 
         * Nepomuk issue and may therefore be handled in conjunction with 
         * a privacy preserving SSD architecture. 
         */
        Resource taskPrivacyState() const;

        /**
         * Set property 'taskPrivacyState'. For the separation between 
         * professional and private purpose of a task, this attribute 
         * provides with the values "professional/private" a high level 
         * separation of privacy in terms of setting distribution rights 
         * to other users for the task. This separation may arise as a general 
         * Nepomuk issue and may therefore be handled in conjunction with 
         * a privacy preserving SSD architecture. 
         */
        void setTaskPrivacyState( const Resource& value );

        /**
         * \return The URI of the property 'taskPrivacyState'. 
         */
        static QUrl taskPrivacyStateUri();

        /**
         * Get property 'taskName'. The Task Name helps the user to identify 
         * a task in a list. It should be expressive enough to give a meaningful 
         * recognition. Details should be written in the description 
         * attribute instead. A name attribute is not allowed to contain 
         * line breaks. 
         */
        QString taskName() const;

        /**
         * Set property 'taskName'. The Task Name helps the user to identify 
         * a task in a list. It should be expressive enough to give a meaningful 
         * recognition. Details should be written in the description 
         * attribute instead. A name attribute is not allowed to contain 
         * line breaks. 
         */
        void setTaskName( const QString& value );

        /**
         * \return The URI of the property 'taskName'. 
         */
        static QUrl taskNameUri();

        /**
         * Get property 'logEntry'. 
         */
        QList<Resource> logEntrys() const;

        /**
         * Set property 'logEntry'. 
         */
        void setLogEntrys( const QList<Resource>& value );

        /**
         * Add a value to property 'logEntry'. 
         */
        void addLogEntry( const Resource& value );

        /**
         * \return The URI of the property 'logEntry'. 
         */
        static QUrl logEntryUri();

        /**
         * Get property 'lastReviewDate'. 
         */
        QDateTime lastReviewDate() const;

        /**
         * Set property 'lastReviewDate'. 
         */
        void setLastReviewDate( const QDateTime& value );

        /**
         * \return The URI of the property 'lastReviewDate'. 
         */
        static QUrl lastReviewDateUri();

        /**
         * Get property 'taskGoal'. 
         */
        QList<Resource> taskGoals() const;

        /**
         * Set property 'taskGoal'. 
         */
        void setTaskGoals( const QList<Resource>& value );

        /**
         * Add a value to property 'taskGoal'. 
         */
        void addTaskGoal( const Resource& value );

        /**
         * \return The URI of the property 'taskGoal'. 
         */
        static QUrl taskGoalUri();

        /**
         * Get property 'actualEndTime'. 
         */
        QDateTime actualEndTime() const;

        /**
         * Set property 'actualEndTime'. 
         */
        void setActualEndTime( const QDateTime& value );

        /**
         * \return The URI of the property 'actualEndTime'. 
         */
        static QUrl actualEndTimeUri();

        /**
         * Get property 'subTask'. 
         */
        QList<Task> subTasks() const;

        /**
         * Set property 'subTask'. 
         */
        void setSubTasks( const QList<Task>& value );

        /**
         * Add a value to property 'subTask'. 
         */
        void addSubTask( const Task& value );

        /**
         * \return The URI of the property 'subTask'. 
         */
        static QUrl subTaskUri();

        /**
         * Get property 'taskSource'. here can be stated from which sources 
         * a task was derived. e.g from another task or from an task pattern 
         */
        Resource taskSource() const;

        /**
         * Set property 'taskSource'. here can be stated from which sources 
         * a task was derived. e.g from another task or from an task pattern 
         */
        void setTaskSource( const Resource& value );

        /**
         * \return The URI of the property 'taskSource'. 
         */
        static QUrl taskSourceUri();

        /**
         * Get property 'contextThread'. 
         */
        Resource contextThread() const;

        /**
         * Set property 'contextThread'. 
         */
        void setContextThread( const Resource& value );

        /**
         * \return The URI of the property 'contextThread'. 
         */
        static QUrl contextThreadUri();

        /**
         * Get property 'taskReference'. 
         */
        Task taskReference() const;

        /**
         * Set property 'taskReference'. 
         */
        void setTaskReference( const Task& value );

        /**
         * \return The URI of the property 'taskReference'. 
         */
        static QUrl taskReferenceUri();

        /**
         * Get property 'importance'. 
         */
        Resource importance() const;

        /**
         * Set property 'importance'. 
         */
        void setImportance( const Resource& value );

        /**
         * \return The URI of the property 'importance'. 
         */
        static QUrl importanceUri();

        /**
         * Get property 'subTaskOrdering'. Ordering of the subtasks 
         * listed in the tmo:subTasks property of this Task. This is only 
         * for ordering/sorting in GUIs, the semantic relation is defined 
         * in subTasks, and if this and subTasks differ, subTasks is the 
         * correct list. 
         */
        Resource subTaskOrdering() const;

        /**
         * Set property 'subTaskOrdering'. Ordering of the subtasks 
         * listed in the tmo:subTasks property of this Task. This is only 
         * for ordering/sorting in GUIs, the semantic relation is defined 
         * in subTasks, and if this and subTasks differ, subTasks is the 
         * correct list. 
         */
        void setSubTaskOrdering( const Resource& value );

        /**
         * \return The URI of the property 'subTaskOrdering'. 
         */
        static QUrl subTaskOrderingUri();

        /**
         * Get property 'attachment'. connects a Task with an Attachment 
         * object. Attachments are associations of Things. 
         */
        QList<Resource> attachments() const;

        /**
         * Set property 'attachment'. connects a Task with an Attachment 
         * object. Attachments are associations of Things. 
         */
        void setAttachments( const QList<Resource>& value );

        /**
         * Add a value to property 'attachment'. connects a Task with an 
         * Attachment object. Attachments are associations of Things. 
         */
        void addAttachment( const Resource& value );

        /**
         * \return The URI of the property 'attachment'. 
         */
        static QUrl attachmentUri();

        /**
         * Get all resources that have this resource set as property 'containsTask'. 
         * \sa ResourceManager::allResourcesWithProperty 
         */
        QList<Resource> containsTaskOf() const;

        /**
         * Get all resources that have this resource set as property 'dependencyMemberA'. 
         * The semantic of this relation is defined in the sublclass of 
         * undirected Dependency on which this property is stated. (The 
         * subject of the statment where this property is expressed) \sa 
         * ResourceManager::allResourcesWithProperty 
         */
        QList<Resource> dependencyMemberAOf() const;

        /**
         * Get all resources that have this resource set as property 'dependencyMemberB'. 
         * The semantic of this relation is defined in the sublclass of 
         * undirected Dependency on which this property is stated. (The 
         * subject of the statment where this property is expressed) \sa 
         * ResourceManager::allResourcesWithProperty 
         */
        QList<Resource> dependencyMemberBOf() const;

        /**
         * Get all resources that have this resource set as property 'taskReference'. 
         * \sa ResourceManager::allResourcesWithProperty 
         */
        QList<Task> taskReferenceOf() const;

        /**
         * Retrieve a list of all available Task resources. This list consists 
         * of all resource of type Task that are stored in the local Nepomuk 
         * meta data storage and any changes made locally. Be aware that 
         * in some cases this list can get very big. Then it might be better 
         * to use libKNep directly. 
         */
        static QList<Task> allTasks();


        /**
         * \return The URI of the resource type that is used in Task instances.
         */
        static QString resourceTypeUri();

    protected:
       Task( const QString& uri, const QUrl& type );
       Task( const QUrl& uri, const QUrl& type );
       Task( const QString& uri, const QUrl& type, ResourceManager* );
       Task( const QUrl& uri, const QUrl& type, ResourceManager* );
    };
}

#endif
