/* This file is part of the Nepomuk Project
   Copyright (c) 2009 Sebastian Trueg <trueg@kde.org>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef _NEPOMUK_FILE_ANNOTATOR_H_
#define _NEPOMUK_FILE_ANNOTATOR_H_

#include <KJob>
#include <KUrl>

namespace Nepomuk {

    class Annotation;

    class FileAnnotator : public KJob
    {
        Q_OBJECT

    public:
        FileAnnotator( const KUrl& url );
        ~FileAnnotator();

    public Q_SLOTS:
        void start();

    private Q_SLOTS:
        void slotNewAnnotation( Nepomuk::Annotation* );
        void slotAnnotationPluginsFinished();

    private:
        class Private;
        Private* const d;
    };
}

#endif
