/*
    Copyright (c) 2009 Charles Wautier <charles.wautier@gmail.com>
    Copyright (c) 2010 Sebastian Trueg <trueg@kde.org>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _KONQUEROR_TASK_PLUGIN_H_
#define _KONQUEROR_TASK_PLUGIN_H_

#include <kparts/plugin.h>

class KActionMenu;

namespace Nepomuk
{
    class AnnotationMenu;
    class ContextServiceInterface;
    class Resource;

    /**
     * A button inserted in Konqueror's ToolBar opening an AnnotationMenu
     */
    class KonquerorTaskPlugin : public KParts::Plugin
    {
        Q_OBJECT

    public:
        KonquerorTaskPlugin(QObject* parent, const QVariantList& args = QVariantList());
        ~KonquerorTaskPlugin();

    private Q_SLOTS:
        void slotLinkToCurrentTask(Qt::MouseButtons, Qt::KeyboardModifiers);
        void slotAnnotationMenuAboutToBeConstucted();
        void slotResourceAnnotatedViaMenu();

    private:
        Nepomuk::Resource createWebsiteResource() const;

        Nepomuk::AnnotationMenu* m_annotationMenu;
        Nepomuk::ContextServiceInterface* m_context;
        KActionMenu* m_action;
    };
}

#endif
