/*
   Copyright (c) 2008 Sebastian Trueg <trueg@kde.org>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef _NEPOMUK_ONTOLOGY_IMPORT_CLIENT_H_
#define _NEPOMUK_ONTOLOGY_IMPORT_CLIENT_H_

#include <QtCore/QObject>
#include <QtCore/QString>

#include <KUrl>

#include "ontologyloaderinterface.h"

namespace Nepomuk {
    class OntologyImportClient : public QObject
    {
        Q_OBJECT

    public:
        OntologyImportClient( QObject* parent = 0 );
        ~OntologyImportClient();

        void importOntology( const KUrl& url );

    private Q_SLOTS:
        void slotOntologyUpdated( const QString& );
        void slotOntologyUpdateFailed( const QString&, const QString& );

    private:
        org::kde::nepomuk::OntologyManager* m_ontologyManagerInterface;
        KUrl m_importOntologyUrl;
    };
}

#endif
