/*
   This file is part of the Nepomuk KDE project.
   Copyright (C) 2009 Sebastian Trueg <trueg@kde.org>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
 */

#ifndef _NEPOMUK_RESOURCE_FORMATTING_RULE_H_
#define _NEPOMUK_RESOURCE_FORMATTING_RULE_H_

#include "resourceformatting.h"
#include "resourceformattingrulefactory.h"

#include <nepomuk/resource.h>
#include <nepomuk/class.h>

#include <QtCore/QSharedDataPointer>

namespace Nepomuk {

    class ResourceFormattingRulePrivate;

    class ResourceFormattingRule
    {
    public:
        ResourceFormattingRule();
        ResourceFormattingRule( const ResourceFormattingRule& );
        ~ResourceFormattingRule();

        ResourceFormattingRule& operator=( const ResourceFormattingRule& );

        bool isValid() const;

        Types::Class type() const;
        QString formatTemplate() const;
        QList<QList<Nepomuk::Types::Property> > properties() const;

        QString formatResource( const Resource& res, ResourceFormattingFlags flags = FormatNoFlags ) const;

    private:
        QExplicitlySharedDataPointer<ResourceFormattingRulePrivate> d;

        friend class ResourceFormattingRuleFactory;
    };
}

#endif
