/*
   This file is part of the Nepomuk KDE project.
   Copyright (C) 2009 Sebastian Trueg <trueg@kde.org>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
 */

#ifndef _NEPOMUK_RESOURCE_FORMATTING_RULE_P_H_
#define _NEPOMUK_RESOURCE_FORMATTING_RULE_P_H_

#include <QtCore/QSharedData>
#include <QtCore/QList>

#include <nepomuk/property.h>
#include <nepomuk/class.h>


namespace Nepomuk {
    class ResourceFormattingRulePrivate : public QSharedData
    {
    public:
        // the type which can be formatted by this rule
        Nepomuk::Types::Class type;

        // a string template with placeholders %1 - %n
        // to be replaced according to properties
        // the default value is "%1" for rules without a template
        QString formatTemplate;

        // the properties to be used to replace placeholders in formatTemplate
        // for each placeholder we have a list of properties which describe
        // the path to the value to format
        QList<QList<Nepomuk::Types::Property> > properties;
    };
}

#endif
