/*  This file is part of the KDE semantic clipboard
    Copyright (C) 2008 Tobias Wolf <twolf@access.unizh.ch>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "remotemappingstorage.h"

#include "mappingelement.h"

SemClip::RemoteMappingStorage::RemoteMappingStorage( const QUrl& service )
    : QueryableMappingStorage(),
      m_service( service ),
      m_mapping( 0 )
{
}

SemClip::RemoteMappingStorage::~RemoteMappingStorage()
{
    delete m_mapping;
}

QUrl SemClip::RemoteMappingStorage::service() const
{
    return m_service;
}

const SemClip::MappingElement* SemClip::RemoteMappingStorage::findMapping( const QUrl& source, const QUrl& target )
{
    delete m_mapping;
    m_mapping = retrieveMapping( source, target );
    return m_mapping;
}

SemClip::MappingElement* SemClip::RemoteMappingStorage::findMappingInternal( const QUrl& source, const QUrl& target )
{
    delete m_mapping;
    m_mapping = 0;
    return retrieveMapping( source, target );
}
