/*  Copyright (C) 2008 Tobias Wolf <twolf@access.unizh.ch>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#ifndef _UNCOPYABLE_H_
#define _UNCOPYABLE_H_

    /**
     * \class Uncopyable uncopyable.h "uncopyable.h"
     *
     * \brief Simple class to disallow copying.
     *
     * Uncopyable is a simple class to disallow copying of any class that
     * inherits from it. Public inheritance is not necessary.
     *
     * \author Tobias Wolf <twolf@access.unizh.ch>
     * \deprecated Use Q_DISABLE_COPY
     */
    class Uncopyable
    {
    protected:
        Uncopyable()
        {
        }

        ~Uncopyable()
        {
        }

    private:
        Uncopyable( const Uncopyable& );

        Uncopyable& operator==( const Uncopyable& );
    };

#endif
