/*
   This file is part of the Nepomuk KDE project.
   Copyright (C) 2010 Sebastian Trueg <trueg@kde.org>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) version 3, or any
   later version accepted by the membership of KDE e.V. (or its
   successor approved by the membership of KDE e.V.), which shall
   act as a proxy defined in Section 6 of version 3 of the license.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _NEPOMUK_RESOURCE_NAVIGATOR_MENU_H_
#define _NEPOMUK_RESOURCE_NAVIGATOR_MENU_H_

#include <QtGui/QMenu>

#include <Nepomuk/Resource>

namespace Nepomuk {

    class ResourceNavigatorPrivate;
    class NavigatorButton;

    class ResourceNavigatorMenu : public QMenu
    {
        Q_OBJECT

    public:
        ResourceNavigatorMenu( ResourceNavigatorPrivate* p, Nepomuk::NavigatorButton* button );
        ~ResourceNavigatorMenu();

        void setResource( const Nepomuk::Resource& res );

    Q_SIGNALS:
        void resourceActivated( Nepomuk::NavigatorButton*, const Nepomuk::Resource& res );

    private Q_SLOTS:
        void slotAboutToShow();
        void slotTriggered( QAction* action );

    private:
        ResourceNavigatorPrivate* m_navigator;
        NavigatorButton* m_button;
        Resource m_resource;

        QAction* m_createNewAction;
    };
}

#endif
