/*
   Copyright (C) 2009 by Sebastian Trueg <trueg at kde.org>
   Copyright (C) 2009 by Charles Wautier <charles.wautier@gmail.org>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include <KApplication>
#include <KCmdLineArgs>
#include <KAboutData>
#include <KDebug>
#include "newtaskdialog.h"

int main(int argc, char *argv[])
{
    KAboutData aboutData("TaskEditor", 0,
                         ki18n("TaskEditor"),
                         "0.1",
                         ki18n("TaskEditor"),
                         KAboutData::License_GPL,
                         ki18n("(c) 2009, Charles Wautier"),
                         KLocalizedString(),
                         "http://nepomuk.kde.org");
    aboutData.addAuthor(ki18n("Charles Wautier"), ki18n("Maintainer"), "charles.wautier@gmail.org");
    aboutData.setProgramIconName("nepomuk");

    KCmdLineArgs::init(argc, argv, &aboutData);

    KCmdLineOptions options;
    KCmdLineArgs::addCmdLineOptions(options);

    KApplication app;

    NewTaskDialog::createNewTask();

    return 0;
}
