/*
   Copyright (c) 2009-2010 Sebastian Trueg <trueg@kde.org>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of
   the License or (at your option) version 3 or any later version
   accepted by the membership of KDE e.V. (or its successor approved
   by the membership of KDE e.V.), which shall act as a proxy
   defined in Section 14 of version 3 of the license.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _MAIN_WINDOW_H_
#define _MAIN_WINDOW_H_

#include <QtGui/QMainWindow>
#include "ui_mainwindow.h"

namespace Nepomuk {
    class TaskModel;
    class TaskFilterModel;
    class ResourceActions;
}
class QEvent;
class QKeyEvent;
class QItemSelection;

class MainWindow : public QMainWindow, public Ui::MainWindow
{
    Q_OBJECT

public:
    MainWindow();
    ~MainWindow();

    bool eventFilter( QObject* o, QEvent* e );

private Q_SLOTS:
    void slotSelectionChanged( const QItemSelection& selected, const QItemSelection& deselected );

private:
    void keyPressEvent( QKeyEvent* event );

    Nepomuk::TaskModel* m_taskModel;
    Nepomuk::TaskFilterModel* m_taskFilterModel;

    Nepomuk::ResourceActions* m_resourceActions;
};

#endif
